/*
 * GeoMOOSE Site Configuration
 */

var CONFIGURATION = {
	'links_bar_html' : "",
	'waiting_html' : 'Loading...',
	'mapserver_url' : "",
	'mapfile_root' : "",
	'mapbook' : "php/getmapbook.php",
	'fractional_zoom' : false,
	'scales' : [1,2,4,8,16,32,64,128,256,500,1000,5000],
	'max_extent' : [189783.560000,4816309.330000,761653.524114,5472346.500000],
	'initial_extent' : [410438.542057,5125011.551363637,540998.542057,5163644.278636363],
	'projection' : "EPSG:26915",
	'ground_units' : 'm',
	'coordinate_display' : {
		xy: true,	/* Ground Units */
		latlon: true,	/* Longitude and Latitude */
		usng: true	/* U.S. National Grid */
	},
	'tabs' : {
		'Catalog' : 'catalog-tab',
		'Information' : 'information-tab',
		'Custom' : 'custom-tab'
	},
	'default_tab' : 'Catalog',
	'catalog_name' : 'Catalog',
	'show_service_settings_in' : 'Information',
	'show_results_in' : 'Information',
	'group_checkboxes' : true,
	'zoomto' : {
/*		
		'Jump To:' : {
			'Dakota County' : [521238.614537864,4924218.86673578,473921.947801381,4974430.36885032],
			'Parcel Data' : [497205.409367,4923984.423582,477595.805945,4941970.52988],
			'Full State of MN' : [189783.560000,4816309.330000,761653.524114,5472346.500000]
		}
*/
	},
	'jumpto_scales' : {
		'1:12000' : 12000,
		'1:2400' : 2400,
		'1:1200' : 1200,
		'1:120' : 120
	},
	'startup_service' : false,
	'layer_controls' : {
		'up' : {on: true, tip: 'Move %LAYER% up on the stack'},
		'down' : {on: true, tip: 'Move %LAYER% down on the stack'},
		'fade' : {on: true, change_percent: 10, tip: 'Fade %LAYER%'},
		'unfade' : {on: true, change_percent: 10, tip: 'Unfade %LAYER%'},
		'refresh' : {on: false, tip: 'Manually refresh %LAYER%'},
		'cycle' : {on: false, tip: 'Refresh %LAYER% every 10 seconds', seconds: 10},
		'legend' : {on: true, tip: 'Show legend for %LAYER%'},
		'metadata' : {on: false, tip: 'Show metadata for %LAYER%'}
	},
	'catalog' : {
		'toggle_controls' : true,
		'show_controls' :  true
	},
	'reference_map' : {
		'enabled' : true,
		'maximized' : true,
		'width': 250,
		'height':  100,
		'minimum_ratio' : 10,
		'maximum_ratio' : 20
	},
	'cursor' : {
		'pan': "url('cursors/pan.cur'),auto",
		'zoomout': "url('cursors/zoomout2.cur'),auto",
		'zoomin': "url('cursors/zoomin2.cur'),auto",
		'measure': "url('cursors/measure2.cur'),auto",
		'measurearea': "url('cursors/measure2.cur'),auto"
	},
	'scale_line' : {
		'enabled' : true,
		'top_units' : 'ft',
		'bottom_units' : 'mi',
		'width' : 200
	},
	'drawing_tools' : {
		'default_fill' : 'green',
		'default_stroke' : 'red',
		'default_opacity' : '.8'
	},
	'measure_tool' : {
		'precision' : 3,
		'style' : {
			"Point" : {
				pointRadius: 4,
				graphicName: "square",
				fillColor: "white",
				fillOpacity: 1,
				strokeWidth: 1,
				strokeOpacity: 1,
				strokeColor: "#333333"
			},
			"Line" : {
				strokeWidth: 2,
				strokeColor: "#FF0000"
			},
			"Polygon" : {
				strokeWidth: 2,
				strokeColor: "#FF0000",
				fillColor: "#00FF00",
				fillOpacity: .5
			}
		},
		'line_units' : 'ft',
		'area_units' : 'acre',
		'show_heading' : false
	},
	popups: {
		autosize: false
	},
	messages: {
		requirement_failure : 'You forgot to fill in a required field!',
		invalid_tool : 'SERVICE CONFIGURATION ERROR! Drawing tool %TOOL% not available!',
		service_config_error : 'SERVICE CONFIGURATION ERROR! You must specify a default tool when setting "show-tools" to "true"!',
		service_not_found : 'Service with the name %SERVICE% cannot be found',
		invalid_response : 'No Valid Response!',
		mapbook_version : 'Specified mapbook version %VERSION% is older than 2.0. No promises this will work.',
		mapbook_required : '%FIELD% must be configured in the mapbook',
		mapbook_param_error : 'Error reading the value of "%FIELD%", please check your mapbook configuration.'
	}
};
