<?php
/*Copyright (c) 2009, Dan "Ducky" Little & GeoMOOSE.org

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.*/

#
# GeoMOOSE Item Query Service
# (c) 2008 Dan "Ducky" Little
#

include('../php/config.php');

# Turn off the warning reporting
#error_reporting(E_ERROR | E_PARSE);

$qlayers = $_REQUEST['layer'];
$queryItem = $_REQUEST['qitem'];
$queryValue = $_REQUEST['qstring'];

$queryFilter = $_REQUEST['filter'];
$zoomToFirst = parseBoolean($_REQUEST['zoom_to_first']);
$highlightResults = parseBoolean($_REQUEST['highlight']);

$mode = $_REQUEST['mode'];

if(!isset($mode)) {
	$mode = 'search';
}

$layersToSearch = explode(':', $qlayers);

$mapbook = getMapbook();
$msXML = $mapbook->getElementsByTagName('map-source');

# Array to store the popups found.
$content = '';
$totalResults = 0;
$firstResult = false;

$resultFeatures = array();
$options = array();

	for($i = 0; $i < $msXML->length; $i++) {
		$node = $msXML->item($i);
		$layers = $node->getElementsByTagName('layer');
		for($l = 0; $l < $layers->length; $l++) {
			$layer = $layers->item($l);
			$layerName = $layer->getAttribute('name');
			$path = $node->getAttribute('name').'/'.$layerName;
			if(in_array($path, $layersToSearch)) {
				$file = $node->getElementsByTagName('file')->item(0)->firstChild->nodeValue;
				# Okay, now it's time to cook
				if(substr($file,0,1) == '.') {
					$file = $CONFIGURATION['root'].$file;
				}
				$map = ms_newMapObj($file);

				# Create an array of query layers
				$queryLayers = array();
				if($layerName == 'all') {
					for($ml = 0; $ml < $map->numlayers; $ml++) {
						array_push($queryLayers, $map->getLayer($ml));
					}
				} else {
					# Turn on the specific layer
					array_push($queryLayers, $map->getLayerByName($layerName));
				}
				if($mode == 'search') {
					# Iterate through the queryLayers...
					foreach($queryLayers as $queryLayer) {
						$queryLayer->set('template', 'x'); //Only set because MS seems to require a template value
						$queryLayer->set('status', MS_DEFAULT);
						$queryString = $queryLayer->getMetaData('itemquery-filter');

						$queryString = str_replace('[qstring]', $queryValue, $queryString);
						$queryLayer->queryByRect($queryLayer->getExtent());

						$queryLayer->open();
						$numResults = $queryLayer->getNumResults();
						if($numResults > 0 and $totalResults == 0) {
							$res = $queryLayer->getResult(0);
							$firstResult = $queryLayer->getShape($res);
						}
						$optionValue = Array();
						for($rx = 0; $rx < $numResults; $rx++) {
							$res = $queryLayer->getResult($rx);
							$optionValue[$rx] = $queryLayer->getShape($res)->values[$queryItem];
						}
						sort($optionValue);
						foreach($optionValue as $option) {
							if(strlen($option) > 0) {
								$contents .= '<option value="' . $option . '">' . $option . '</option>';
							}
						}
					}
				}
				if($mode == 'map') {
					# Iterate through the queryLayers...
					foreach($queryLayers as $queryLayer) {
						$queryLayer->set('template', $queryLayer->getMetaData('itemquery'));
						$queryLayer->set('status', MS_DEFAULT);
						$queryString = $queryLayer->getMetaData('itemquery-filter');
						$queryString = str_replace('[qstring]', $queryValue, $queryString);
						$queryLayer->setFilter($queryString);
						$filterItem = $queryLayer->getMetaData('itemquery-filteritem');
						if($filterItem) {
							$queryLayer->set('filteritem', $filterItem);
						}
						if($queryItem) {
							$queryLayer->set('filteritem', $queryItem);
						}
						$queryLayer->queryByRect($queryLayer->getExtent());

						$queryLayer->open();
						$numResults = $queryLayer->getNumResults();
						if($numResults > 0 and $totalResults == 0) {
							$res = $queryLayer->getResult(0);
							$firstResult = $queryLayer->getShape($res);
						}
						for($rx = 0; $rx < $numResults; $rx++) {
							$res = $queryLayer->getResult($rx);
							array_push($resultFeatures, $queryLayer->getShape($res));
						}
						$totalResults += $numResults;
						$queryLayer->close();
					}
				}
				$totalResults += $numResults;
				$queryLayer->close();

			}
		}
	}
if($mode == 'search') {
	header('Content-type: text/xml');
	print "<results>";
	print $contents;
	print "</results>";
}

elseif($mode == 'map') {
	header('Content-type: text/xml');
	print "<results>";
	print "<script><![CDATA[";
	print "GeoMOOSE.turnLayerOn('$qlayers');\n";
	print "Tabs.showTab('Map Layers');\n";
	$bounds = $firstResult->bounds;
	printf('GeoMOOSE.zoomToExtent(%f,%f,%f,%f);', $bounds->minx, $bounds->miny, $bounds->maxx, $bounds->maxy);
	print "]]></script>";
	print "</results>";

} else {
	header('Content-type: text/html');
	print '<html><body>Error! Unknown mode!</body></html>';
}

function parseBoolean($p) {
	return($p == 1 || $p == '1' || strtolower($p) == 'true' || strtolower($p) == 'on');
}
?>
